# Watchbot

Maintainer: Jakob Moser <moser@cl.uni-heidelberg.de>

Watchbot consists of two components: A script that restarts all services that are currently running and Traefik, and a script that detects when Traefik is down.

## 📜 About the procedure

Sadly, it sometimes happens that Traefik, our reverse proxy crashes, rendering all services unavailable. This means: If the ticket system, the website, the todo tool etc. all decide to go down at once, it is probably just Traefik.

The solution appears simple: Just restart Traefik!

However, this will sadly fail, because some other container always snatches the IP address Traefik wants to receive. Therefore, all services need to be stopped, then Traefik needs to be started, then the other services need to be started. This script does all of this.

## 🤖 Run watchbot

Edit your crontab (`sudo crontab -e`) to include the following line:

```
*/3     *       *       *       *       /coli/watchbot/watchbot.sh
```

This will run the script every 3 minutes to check if something is down and trigger a restart if needed.

## 🔃 Restart

If a restart ever becomes necessary, SSH into `lennon` and execute:

```bash
sudo /coli/watchbot/restart.sh
```
